#!/bin/sh
# 
# Script fuer das automatische Verschieben der Logfiles ins
# Homeverzeichnis von Admin
#
# Zuletzt geaendert am: 03.12.2003
# Autor: Lars Rupp <l.rupp@web.de>
#

# Variablen
logdir="/home/admin/gee/logs"
platz=`df -h`
ulogdir="squid news httpd squidGuard samba"
datum=`date +%d.%m.%y`

# Sicherheitskontrolle: Verzeichnis existiert?
test -d $logdir || mkdir -p $logdir 

for i in $ulogdir; do
  test -d $logdir/$i || mkdir -p $logdir/$i
done

# alte Logbuecher aus /var verschieben, Fehlermeldungen ignorieren
mv /var/log/*.gz $logdir 2> /dev/null
mv /var/squid/logs/*.gz $logdir/squid 2> /dev/null
mv /var/squidGuard/logs/*.gz $logdir/squidGuard 2>/dev/null
mv /var/log/samba/*.gz $logdir/samba 2>/dev/null
mv /var/log/news/*.gz $logdir/news 2> /dev/null
mv /var/log/httpd/*.gz $logdir/httpd 2> /dev/null
gzip /tmp/dead.letter 2>/dev/null
mv /tmp/dead.letter.gz $logdir/$datum.dead.letter.gz 2>/dev/null
if [ -e /var/log/samba/info.log ]; 
    then
    gzip /var/log/samba/info.log 2>/dev/null
    mv /var/log/samba/info.log.gz /$logdir/$datum.info.log.gz 2>/dev/null
    touch /var/log/samba/info.log
fi

# Rechte setzen:
chown -R admin.users $logdir/* 
chmod -R 700 $logdir/* 

# Alte temporaere Dateien loeschen
rm /tmp/php* 2>/dev/null
rm /tmp/sess* 2>/dev/null
rm /tmp/.SuS* 2>/dev/null
rm /tmp/extfs* 2>/dev/null
rm -r /var/tmp/* 2>/dev/null

# Meldung an Nutzer
echo "Alte Logbuecher wurden am $datum nach $logdir verschoben."
echo "/tmp und /var/tmp wurden aufgeraeumt." 
echo "Derzeitiger Platzverbrauch:"
echo "$platz"
echo

