#!/usr/bin/perl -w

# mailcheck.p (c) Stephan Schn Dezember 2001
# Aufruf als root/admin mit  
# /home/admin/gee/scripts/mailcheck.pl [Dateialter] [Modus]
# Dateialter in s, kann weggelassen werden, dann werden alle
# Postfachdateien jeden Alters geprueft. Fr den Einsatz in
# /home/admin/gee/scripts/mailtausch sollte ein Wert wie
# z.B. 120 angegeben werden. Unbedingt ausprobieren!
# Modus gibt an, ob die empfangenen Mails (Modus=ein) oder
# die zu versendenden Mails (Modus=aus) geprft werden. Falls Modus
# nicht angegeben wird, wird als Vorgabe Modus=ein gesetzt.
# Beispiele: 
# 1. /home/admin/gee/scripts/mailcheck.pl aus    prft ausgehende
#    Mails jeden Alters
# 2. /home/admin/gee/scripts/mailcheck.pl 120 ein   prft eingehende
#    Mails, die nicht lter als 120 Sekunden sind

# Voraussetzungen:
# 1. Konfigurationsverzeichnis /etc/mailcheck ist angelegt und mit
#    mailcheck.con und div. Templates gefllt
# 2. f-prot ist installiert und luft
# 3. Verzeichnis /home/admin/gee/virus ist angelegt (Quarantneverzeichnis)   
# 4. Verzeichnis /home/admin/gee/virus/tmp ist angelegt (fr temp. Dateien)
# 5. Konf.-Datei mailcheck.conf ist aktualisiert


use Fcntl ":flock" ;

my $fpalarmdat = "/tmp/fpalarm" ;

if (!(-e "/usr/local/f-prot/f-prot")) {
  my $fpalarm = "F-Prot-Installation fehlerhaft! Abbruch der Aktion... \n\n" ;
  print $fpalarm ;
  open (FPREP,">$fpalarmdat") ;
  print FPREP "F-Prot-Installation fehlerhaft!\n" ;
  close (FPREP) ;
  system ("mail viradmin -s \"F-Prot-Fehler\" < $fpalarmdat ") ; 
  exit ;
}    

my $postfach = "/var/spool/mail" ;
my $etcdir = "/etc/mailcheck/" ;
my $quardatei = "$postfach/quarantine" ;

my $scriptdir ="/home/admin/gee/scripts" ;
my $tempdir= "/tmp/mailcheck" ;
my $tempbrief = "$tempdir/brief.txt" ;
my $fpantwort = "$tempdir/fpantwort.txt" ;
my @alletempdat = &liestempdir ;
my ($servername,$postmaster,$inspooldir,$outspooldir) ;
my ($modus,$verbose,$maxalter,$maildatei,@pfach,$amaildatei) ;
my ($geaendert,$eaenderung,$datei,$beschreibung) ;

# sicher ist sicher
system ("mkdir -p $tempdir") ;

&konfiguration ;

# Vorbesetzung fr den Fall, dass keine comline-Parameter bergeben werden
$maxalter = 0 ;
$modus = 0 ;
$verbose = 0 ;
$spooldir = $inspooldir ;

if (defined(@ARGV)) { 
  foreach $param (@ARGV) {
     if ($param=~ /^[0-9]$/) {
       # Alter auslesen
       $param=~ s/a//g ;
       $maxalter = $param ;
     } elsif (uc($param) eq "AUS") {
       $modus = 1 ;
       $spooldir = $outspooldir ;
     } elsif (uc($param) eq "-V") {
       $verbose = 1 ;  
     }
  }
}  
# Dateien aus dem Spoolverzeichnis holen
@pfach = &maildateien ;
foreach $maildatei (@pfach) {
  $amaildatei = $maildatei ;
  $geaendert = 0 ;
  if (($maildatei ne "root")&&($maildatei ne "admin")) {
    @briefe = &einzelbriefe ($maildatei) ;
    my @neuinhalt = () ;
    foreach $ebrief (@briefe) {
      if ($ebrief=~ /ype\: [mM]ultipart\//) {
        $ebrief = &bearbeitemime ($ebrief,$eaenderung) ;
        $geaendert = 1 if ($eaenderung > 0) ;
      } 
      if ($ebrief ne "") {
        push (@neuinhalt,$ebrief) ;
      }
    }
    if ($geaendert > 0) {
      &schreibepostfach ($maildatei,@neuinhalt) ;
      if ($verbose == 1) {
        print "Warnung - Virus bei $maildatei\n" ;
      }
    } else {
      if ($verbose == 1) {
        print "ok - kein Virus bei $maildatei\n" ;
      }
    }
  }
}

sub bearbeitemime {
  # eine multipart- mail auf Viren untersuchen
  my $inhalt = $_[0] ;
  my @rest=() ;
  my ($to,$from,$fpmeldung,$haupt,$fpreply,$subject,$date) ;
  $_[1] = 0 ;
  my $zeit = time ;
  my @temp = split (/\n/,$inhalt) ;
  ($to,@rest) = grep (/To\:/,@temp) ;
  ($from,@rest) = grep (/From\:/,@temp) ;
  ($date,@rest) = grep (/Date\:/,@temp) ;
  ($subject,@rest) = grep (/Subject:/,@temp) ;
  $to=~ s/To\: //g ;
  $from=~ s/From\: //g ;
  ($haupt,@rest) = split (/\@/,$to) ;
  system ("mkdir -p /tmp/virreport") ;
  $tempbrief =  "/tmp/virreport/$zeit-$haupt.txt" ;
  &schreibetemp ($inhalt) ;  
  $fpreply = `/usr/local/f-prot/f-prot $tempbrief -archive -dumb -packed -report=/tmp/fpreply.txt` ;
  unlink $tempbrief ;
  if (!($fpreply=~ /Infection:/)) {
  # kein Virus
    return $inhalt ;
  } 
  # ab jetzt: Virus gefunden
  my @fplines = split (/\n/,$fpreply) ;
  ($fpmeldung,@rest)  = grep (/Infection:/,@fplines) ;
  ($datei,$beschreibung) = split (/  /,$fpmeldung) ;
  $beschreibung=~ s/Infection\:/Infektion\:/g ;
  my @part = split (/\-\>/,$datei) ;
  $datei = $part[1] ;
  &viruswarnmail ($to,$from,$subject,$datei,$beschreibung,$date) ;
  &quarantaene ($inhalt) ;
  $_[1] = 1 ;
  return "" ; # leerer Brief heisst eMail geloescht 
} # bearbeitetmime

sub viruswarnmail {
  my ($to,$from,$subject,$datei,$beschreibung,$date) = @_ ;
  my @wohininf = ("ausgehender","eingehender") ;
  my $modus = ($spooldir eq $inspooldir) ;
  my $wohin = $wohininf[$modus] ;
  my $vsubject = "\"Virus-Alarm bei $wohin  Mail\"" ;
  my $alarm = "=============== Virusalarm ==================\n";
  $alarm.= "\nIn der nachfolgend beschriebenen eMail wurde auf $servername ein Virus entdeckt!\n" ;
  $alarm.= "Von: $from\nAn: $to\n$subject\n$date\n\nDateianhang: $datei\nVirus-Beschreibung: $beschreibung\n" ;
  &schreibetemp ($alarm) ;
  system ("mail viradmin -s $vsubject <$tempbrief") ;
  my $ergaenzung = "\nDer Brief wurde nicht ausgeliefert, um Folgeschaeden zu vermeiden.\n" ;
  $ergaenzung.= "\nWeitere Informationen erhalten Sie ggf. bei $postmaster .\n" ;
  &haengeantemp ($ergaenzung) ;
  # mieser Code, nochmal draufschauen!
  my ($uname,$domaene,$rest1,$rest2) ;
  if ($modus == 0) {
     if (!($from=~/\@/)) {
       $to = $from
     } else {      
       $from=~s/ //g ;
       my @part = split (/\@/,$from) ;
       if ($part[0]=~/[\<\>\(\)]/) {
         ($rest1,$uname) = split (/[\<\>\(\)]/,$part[0]) ;
       } else {
         $uname = $part[0] ;
       }          
       if ($part[1]=~/[\<\>\(\)]/) {
         ($domaene,$rest2) = split (/[\<\>\(\)]/,$part[1]) ;
       } else {
         $domaene = $part[1] ;
       }
       $to = $uname."\@".$domaene ; 
     }
    system ("mail $to -s $vsubject <$tempbrief") ;
  }
  unlink $tempbrief ;
}

sub quarantaene {
  my ($inhalt) = @_ ;
  open (TEMP,">>$quardatei") or die "Kann $quardatei nicht oeffnen!\n" ;
  flock (TEMP,LOCK_EX) ;
  print TEMP $inhalt ;
  close (TEMP) ;
}

sub liestempdir {
  opendir (TEMP,$tempdir) ;
  my @alledat = readdir (TEMP) ;
  shift (@alledat) ;
  shift (@alledat) ;
  closedir (TEMP) ;
  return @alledat 
}

sub cleartempdir {    
  @alletempdat=&liestempdir ;
  foreach $datei (@alletempdat) {
    unlink "$tempdir/$datei" ;
  }  
  @alletempdat = () ;
}

sub schreibetemp {
  my $inhalt = $_[0] ;
  open (TBRIEF,">$tempbrief") or die "Kann $tempbrief nicht oeffnen!\n";
  flock (TBRIEF,LOCK_EX) ;
  print TBRIEF $inhalt ;
  close (TBRIEF) ;
}
  
sub haengeantemp {
  my $inhalt = $_[0] ;
  open (TBRIEF,">>$tempbrief") or die "Kann $tempbrief nicht oeffnen!\n";
  flock (TBRIEF,LOCK_EX) ;
  print TBRIEF $inhalt ;
  close (TBRIEF) ;
}


sub einzelbriefe {
  my $maildatei = $_[0] ;
  my @inhalt = &liesdatei ("$spooldir/$maildatei") ;
  my @brief = () ;
  my $ebrief = "" ;
  foreach $iline (@inhalt) {
    if ($iline=~ /\bFrom .+\@/) {
      push (@brief,$ebrief) ;
      $ebrief = $iline ;
    } else {
        $ebrief.= $iline ;
    }
  } 
  push (@brief,$ebrief) ;    
  shift (@brief) ;
  return @brief ;
}


sub maildateien {
  system ("ls $spooldir > /tmp/mboxes.txt") ;
  my @mboxlines = &liesdatei ("/tmp/mboxes.txt") ;
  my @mbox=() ;
  my $azeit = time ;
  foreach $mline (@mboxlines) {
    $mline=~ s/\n|\r| //g ;
    next if ($mline=~ /^\./) ;
    next if ($mline eq "quarantine") ;
    my @faecher = split (/ /,$mline) ;
    foreach $maildatei (@faecher) {
      my @filestat = stat ("$spooldir/$maildatei") ;
      my $fileage = $azeit - $filestat[9] ;
      if (($maxalter == 0)||($fileage < $maxalter)) {
        push (@mbox,@faecher) ;
      }
    }
  }
  return @mbox
}

sub schreibepostfach {
  my ($maildatei,@inhalt) = @_ ;
  if (scalar(@inhalt) == 0) {
    unlink ("$spooldir/$maildatei") ;
  } else {
    &schreibedatei  ("$spooldir/$maildatei",@inhalt) ;
  }
}

sub schreibedatei {
  my ($datnam,@inhalt) = @_ ;
  open (TEMP,">$datnam") or die "Kann $datnam nicht oeffnen!\n" ;
  flock (TEMP,LOCK_EX) ;
  print TEMP @inhalt ;
  close (TEMP) ;
}

sub liesdatei {
  my $dname = $_[0] ;
  open (TEMP,"<$dname") or die "Kann $dname nicht oeffnen!\n" ;
  flock (TEMP,LOCK_SH) ;
  my @zeilen = <TEMP> ;
  close (TEMP) ;
  return @zeilen ;
}

sub konfiguration {
  my @kfgzl =   &liesdatei($etcdir."mailcheck.conf") ;
  for (@kfgzl) {
    $_=~ s/#.*|\n|\r| .+//g ;
    next if ($_ eq "") ;
    if (/=/) {
       my ($variable,$wert) = split (/=/,$_) ;
       if (uc($variable) eq "SERVERNAME") { $servername = $wert }
       elsif (uc($variable) eq "INSPOOLDIR") { $inspooldir = $wert }
       elsif (uc($variable) eq "OUTSPOOLDIR") { $outspooldir = $wert }
       elsif (uc($variable) eq "POSTMASTER") { $postmaster = $wert }
    }
  }
}

