#!/usr/bin/perl -w

# Versionsdatum 7.5.02 11.00
# Autor S.Schoen, Lizenz GPL

use Fcntl ":flock" ;

my $fpalarmdat = "/tmp/fpalarm" ;

if (!(-e "/usr/local/f-prot/f-prot")) {
  my $fpalarm = "F-Prot-Installation fehlerhaft! Abbruch der Aktion... \n\n" ;
  print $fpalarm ;
  open (FPREP,">$fpalarmdat") ;
  print FPREP "F-Prot-Installation fehlerhaft!\n" ;
  close (FPREP) ;
  system ("mail viradmin -s \"F-Prot-Fehler\" < $fpalarmdat ") ; 
  exit ;
}    

my ($tempbrief,$fpreplydat,$fpreply,$postmaster,$kontrolle,$datei,$beschreibung) ;

my $postfach = "/var/spool/mail" ;
my $etcdir = "/etc/mailcheck/" ;
my $quardatei = "$postfach/quarantine" ;
my $zeit = time ;



&konfiguration ;

my $inhalt = &liesbrief ; # Inhalt der Mail
&bearbeitemime ($inhalt) ;

####################################################

sub bearbeitemime {
  # eine multipart- mail auf Viren untersuchen
  my $inhalt = $_[0] ;
  my @rest=() ;
  my ($to,$from,$date,$fpmeldung,$haupt,$fpreply,$subject) ;
  $_[1] = 0 ;
  my @temp = split (/\n/,$inhalt) ;
  ($to,@rest) = grep (/To\:/,@temp) ;
  ($from,@rest) = grep (/From\:/,@temp) ;
  ($subject,@rest) = grep (/Subject:/,@temp) ;
  ($date,@rest) = grep (/Date:/,@temp) ;
  $to=~ s/To\: //g ;
  $from=~ s/From\: //g ;
  ($haupt,@rest) = split (/\@/,$to) ;
  system ("mkdir -p /tmp/virreport/$haupt") ;
  system ("chmod 0777 /tmp/virreport/$haupt") ;
  $tempbrief =  "/tmp/virreport/$haupt/$zeit.txt" ;
  $fpreplydat = "/tmp/virreport/$haupt/fpreply.txt" ;
  $kontrolle = "/tmp/virreport/$haupt/fpkontrolle.txt" ;
  &schreibetemp ($inhalt) ;  
  $fpreply = `/usr/local/f-prot/f-prot $tempbrief -archive -dumb -packed -report=$fpreplydat` ;
#  unlink $tempbrief ;
  &schreibedatei ($kontrolle,($fpreply)) ;
  if (!($fpreply=~ /Infection:/)) {
  # kein Virus, procmail darf weiter machen
    exit 1 ;
  } else {
    # Virus gefunden
    my @fplines = split (/\n/,$fpreply) ;
    ($fpmeldung,@rest)  = grep (/Infection:/,@fplines) ;
    ($datei,$beschreibung) = split (/ Infection:/,$fpmeldung) ;
    $beschreibung= "Infektion: ".$beschreibung ;
    my @part = split (/\-\>/,$datei) ;
    $datei = $part[1] ;
    &viruswarnmail ($to,$from,$subject,$datei,$beschreibung,$date) ;
    &quarantaene ($inhalt) ;
    # Ende von: Virus in einer Multipart-Mail gefunden
    # Virus-Mail ist entfernt, keine weitere Aktion noetig
    exit 0
  }
} # bearbeitemime

sub viruswarnmail {
  my ($to,$from,$subject,$datei,$beschreibung,$date) = @_ ;
  my $vsubject = "\"Virus-Alarm bei eingehender Mail\"" ;
  my $alarm = "=============== Virusalarm ==================\n";
  $alarm.= "\nIn der nachfolgend beschriebenen eMail wurde auf $servername ein Virus entdeckt!\n" ;
  $alarm.= "Von: $from\nAn: $to\n$subject\n$date\n\nDateianhang: $datei\nVirus-Beschreibung: $beschreibung\n" ;
  &schreibetemp ($alarm) ;
  system ("mail viradmin -s $vsubject <$tempbrief") ;
  my $ergaenzung = "\nDer Brief wurde nicht ausgeliefert, um Folgeschaeden zu vermeiden.\n" ;
  $ergaenzung.= "Bitte benachrichtigen Sie Ihren Korrespondenzpartner von dem Virusbefall!\n" ;
  $ergaenzung.= "\nWeitere Informationen erhalten Sie ggf. bei $postmaster .\n" ;
  &haengeantemp ($ergaenzung) ;
  system ("mail $to -s $vsubject <$tempbrief") ;
  unlink $tempbrief ;
}

sub liesbrief {
  # ... aus der Standardeingabe
  my $ebrief = "" ;
  while (<STDIN>) {
    $ebrief.= $_ ;
  }
  print $ebrief ;
  return $ebrief
}

sub schreibetemp {
  my $inhalt = $_[0] ;
  open (TBRIEF,">$tempbrief") or die "Kann $tempbrief nicht oeffnen: $!" ;
  flock (TBRIEF,LOCK_EX) ; #exklusiv sperren
  print TBRIEF $inhalt ;
  close (TBRIEF) ;
}

sub haengeantemp {
  my $inhalt = $_[0] ;
  open (TBRIEF,">>$tempbrief") or die "Kann $tempbrief nicht oeffnen: $!" ;
  flock (TBRIEF,LOCK_EX) ; #exklusiv sperren
  print TBRIEF $inhalt ;
  close (TBRIEF) ;
}

sub quarantaene {
  my ($inhalt) = @_ ;
  open (TEMP,">>$quardatei")  or die "Kann $quardatei nicht oeffnen: $!";
  flock (TEMP,LOCK_EX) ; #exklusiv sperren
  print TEMP $inhalt ;
  close (TEMP) ;
}

sub schreibedatei {
  my ($datnam,@inhalt) = @_ ;
  open (TEMP,">$datnam")  or die "Kann $datnam nicht oeffnen: $!";
  flock (TEMP,LOCK_EX) ; #exklusiv sperren
  print TEMP @inhalt ;
  close (TEMP) ;
}

sub liesdatei {
  my $dname = $_[0] ;
  open (TEMP,"<$dname")  or die "Kann $dname nicht oeffnen: $!";
  flock (TEMP,LOCK_SH) ;
  my @zeilen = <TEMP> ;
  close (TEMP) ;
  return @zeilen ;
}

sub konfiguration {
  my @kfgzl =   &liesdatei($etcdir."mailcheck.conf") ;
  for (@kfgzl) {
    $_=~ s/#.*|\n|\r| .+//g ;
    next if ($_ eq "") ;
    if (/=/) {
       my ($variable,$wert) = split (/=/,$_) ;
       if (uc($variable) eq "SERVERNAME") { $servername = $wert }
       if (uc($variable) eq "POSTMASTER") { $postmaster = $wert }
    }
  }
}

