#!/bin/sh
#
insmod=`which insmod`
rmmod=`which rmmod`
ipchains=`which ipchains`
lsmod=`which lsmod`
modules="ip_masq_autofw ip_masq_ftp ip_masq_irc ip_masq_portfw"

# Funktion zur Sicherheitsueberpruefung ;-)
module()
{
    $lsmod | grep "^$1 " > /dev/null
}

case "$1" in
 'on')
    # Forwarding einschalten
    $ipchains -P forward MASQ
    # Module laden 
    for i in $modules; do
        if ! module $i ; then
         $insmod $i > /dev/null
        fi
    done
    # Ausgabe an Benutzer
    echo \<br\> 
    echo \<b\>
    echo \<font color\=\#FF0000\>
    echo Das Masquerading wurde eingeschaltet.
    echo \<br\>
    echo Dies ist nicht die Standardeinstellung des Servers und wird \<br\>
    echo sp\&auml\;testens um 02:00 Uhr r\&uuml\;ckg\&auml\;ngig gemacht.\<br\>
    echo \<\/font\>
    echo \<\/b\>
    echo \<br\>
    echo \<br\>
    /sbin/init.d/./gee-firewall status > /dev/null
    ;;
 'off')
    # Forwarding ausschalten
    $ipchains -P forward REJECT
    # Module entladen 
    for i in $modules; do
	if module $i; then
	 $rmmod $i > /dev/null
	fi
    done
    # Ausgabe an Benutzer
    echo \<br\>
    echo \<b\>
    echo \<font color\=\#008000\>
    echo Das Masquerading wurde ausgeschaltet.
    echo \<br\>
    echo \<\/font\>
    echo \<\/b\>
    echo \<br\>
    echo \<br\>
    /sbin/init.d/./gee-firewall status > /dev/null
    ;;
 *)
    echo "Aufruf: $0 {on|off}"
    ;;
esac
