#!/usr/bin/perl -w

# Eintrag einer machine-Zeile in /root/.netrc
# wird benoetigt zum Signatur-Update

my $mailcheckconf = "/etc/mailcheck/mailcheck.conf" ;
my $getfpsign = "/home/admin/gee/scripts/getfpsign" ;
my $netrc = "/root/.netrc" ;

my ($postmaster,$ftpaddr) ;
my $defaultzeile = ""  ;

&konfiguration ;
&ftpadresse ;

my $machzeile = "machine $ftpaddr login anonymous password $postmaster\n" ;

my @netrc = &liesdatei ($netrc) ;
my @netrcneu = () ;

foreach $zeile (@netrc) {
  if ($zeile=~ /^machine $ftpaddr/) {
  # kein Neuschreiben noetig
    exit ;
  } 
  if ($zeile=~ /^default/) {
    # muss ganz ans Ende, also zwischenlagern
    $defaultzeile = $zeile ;
  }  else {
    push (@netrcneu,$zeile)
  }
}
push (@netrcneu,$machzeile) ;
if ($defaultzeile ne "") {
  push (@netrcneu,$defaultzeile) ;
}
&schreibedatei ($netrc,@netrcneu) ;

sub schreibedatei {
  my ($datnam,@inhalt) = @_ ;
  open (TEMP,">$datnam") ;
  print TEMP @inhalt ;
  close (TEMP) ;
}

sub liesdatei {
  my $dname = $_[0] ;
  open (TEMP,"<$dname") ;
  my @zeilen = <TEMP> ;
  close (TEMP) ;
  return @zeilen ;
}

sub konfiguration {
  my @kfgzl =   &liesdatei($mailcheckconf) ;
  for (@kfgzl) {
    $_=~ s/#.*|\n|\r| .+//g ;
    next if ($_ eq "") ;
    if (/=/) {
       my ($variable,$wert) = split (/=/,$_) ;
       if (uc($variable) eq "POSTMASTER") { $postmaster = $wert }
    }
  }
}

sub ftpadresse {
  # FTP-Adresse und Verzeichnis auslesen
  $ftpaddr = "ftp://ftp.frisk.is/pub/" ;
  if (!(open(TEMP,"<$getfpsign"))) {
    return 
  }
  close (TEMP) ;
  my @kfgzl =   &liesdatei($getfpsign) ;
  for (@kfgzl) {
    next if ($_ eq "") ;
    if (/\bftp/) {
      my ($dummy,$rest) = split (/ftp\:\/\//,$_) ;
      my ($addr,@rest) = split (/ /,$rest) ;
      my $slpos = index ($addr,"/") ;
      $ftpaddr = substr($addr,0,$slpos) ;
      last
    }
  }
}
