#!/usr/bin/perl -w

####################################################################
# vscanall.pl Autor S.Schoen November 2001Februar 2002
# /root/pdaten/vscanall.pl startet fuer alle Benutzer eine
# Virusueberpruefung mit F-Prot in ihren Heimatverzeichnissen.
# Die Reports werden nach /tmp/<benutzername>.virus geschrieben.
# Sollte ein Virusbefall entdeckt werden, werden folgende
# Massnahmen veranlasst:
#  1. Die infizierte Datei wird entfernt, eine Kopie der Datei
#     wird nach /home/admin/gee/virus/<Benutzername> gelegt.
#  2. Eine Viruswarnung mit dem von F-Prot generierten Reprt
#     wird an das Postfach  viradmin geschickt. Falls das Verzeichnis
#     einem Benutzer gehoert, wird auch an ihn eine Warnung verschickt.
#
# Aufruf: /<Pfad>/vscanall.pl [-a] [-a] [-v] [Verz.] [Verz.]
# -v : verbose-modus, d.h. Informationen |ber alle gescannten
#      Verzeichnisse an viradmin schicken
# -o : Scannen derjenigen Verzeichnisse, die in der Konfigurationsdatei
#      /etc/mailcheck/mailcheck.conf als oeffentlich benannt sind 
# -a : alle Verzeichnisse unter /home scannen, die nicht einem 
#      Benutzer zugeordnet sind
# -u : alle Benutzerverzeichnisse scannen
# die uebrigen in der Aufrufzeile angegebenen Verzeichnisse muessen
# direkt unter der Wurzel / liegen, Unterverzeichnisse sind nicht
# zulaessig.
# Beispiel: /home/admin/gee/scripts/vscanall.pl -a -v /tmp /root /frei /home/tausch home/schueler /home/lehrer
#           scannt alle Nicht-Benutzer-Verzeichnisse unter /home und
#           zusaetzlich /tmp, /root und /frei, ferner die Verzeichnisse
#           /home/tausch, /home/schueler und /home/lehrer.
#           Ein ausfuehrlicher Bericht wird an viradmin geschickt.
####################################################################

my $fpalarmdat = "/tmp/fpalarm" ;

if (!(-e "/usr/local/f-prot/f-prot")) {
  my $fpalarm = "F-Prot-Installation fehlerhaft! Abbruch der Aktion... \n\n" ;
  print $fpalarm ;
  open (FPREP,">$fpalarmdat") ;
  print FPREP "F-Prot-Installation fehlerhaft!\n" ;
  close (FPREP) ;
  system ("mail viradmin -s \"F-Prot-Fehler\" < $fpalarmdat ") ; 
  exit ;
}    

my $tempdir = "/tmp/virreport" ;
my $quardir = "/home/admin/gee/virus" ;
my $confdat = "/etc/mailcheck/mailcheck.conf" ;

my @zusatz = @ARGV ;
my @benutzer = &benutzerliste ;  
my @sonstige = &sonstliste ;
my @oeffentlich = &oeffliste ;

my $verbose = 0 ;
my @hdirlist = () ;

my $azeit = time ;
my $virusreport = "Virusreport: Schalter: " ;
my $trlinie = "\n======================================================================\n" ;


# Modus-Einstellungen und Schalter auslesen
foreach $param (@zusatz) {
  if ($param eq "-v") {
  # geschwaetzig scannen
    $verbose = 1 ;
  }
  $virusreport.= " $param" ;
}
$virusreport.= $trlinie."\n\n" ;

# Scannen
foreach $param (@zusatz) {
  # zusaetzliche Verz. scannen
  if ($param eq "-a") {
    # alle Verz unter /home scannen
    foreach $hsonst (@sonstige) {
       &scanhomedir ($hsonst,0)
    }
    next
  }
  if ($param eq "-u") {
  # Benutzerverzeichnisse scannen
    foreach $user (@benutzer) {
      &scanhomedir ($user,1)    
    }
    next 
  }
  if ($param eq "-o") {
    foreach $verz (@oeffentlich) {
      &scanhomedir ($verz,2) ;
    }
    next 
  }
  if ($param eq "-v") { next }
  
  # jetzt bleibt nur: Verz. scannen
  &scanhomedir ($param,2)
}
if ($verbose == 1) {
  &schreibereport ;
}

##################################################

sub schreibereport {
  my $virtemp = "$tempdir/_virusreport" ;
  open (TEMP,">$virtemp") ;
  print TEMP $virusreport ;
  close (TEMP) ;
  system ("mail viradmin -s \"Virusreport\" <$virtemp") ; 
  unlink $virtemp ;
}

sub scanhomedir {
  my ($auser,$iuser) = @_ ;
  my $virusinfo = "$auser.virus" ;
  $virusinfo=~ s/\//_/g ;
  $virusinfo = "$tempdir/$virusinfo" ;
  my $alarm = 0 ;
  if ($iuser == 1) {  
    $aemail = $auser ;
    $auser = "/home/$auser" ;
  }
  $auser = "/".$auser if (!($auser=~/\//)) ;
  $auser=~ s/\/\//\//g ;
  my $persinfo = "*********** Virusalarm im Verzeichnis $auser *****************" ;
  system ("/usr/local/f-prot/f-prot $auser -archive -packed -dumb -report=$virusinfo >/dev/nul") ;
  chmod (0644,"$virusinfo") ;
  open (FPREP,"<$virusinfo") ;
  my $fpinfo = join ("",<FPREP>) ;
  my $mcode = chr(10).chr(0) ;
  my $ocode = chr(10) ;
  $fpinfo=~ s/$mcode/$ocode/g  ;
  my $scaninfo = " ok " ;
  close (FPREP) ;
  my $vdatliste = "" ;
  if (!($fpinfo=~ /No viruses or suspicious files\/boot/)) {
    $alarm = 1 ;
    $scaninfo = " VIRUSALARM " ;
    &quarantaene ($fpinfo,$auser,$vdatliste) ;
    $persinfo = "$persinfo\nInfizierte Dateien wurden entfernt und auf dem Server gesichert:\n$vdatliste" ;
# .$fpinfo ;
    if ($iuser == 1) { 
      $fpinfo = "Setzen Sie sich bitte schnellstens mit einem Systemverantwortlichen in Verbindung!\n".$persinfo.$fpinfo ;
    }
  }
  if ($verbose == 1) {
    $virusreport.= "========= ".$auser.$scaninfo." =============".$trlinie.$fpinfo.$trlinie."\n" ;
  }
  open (FPREP,">$virusinfo") ;
  print FPREP $fpinfo ;
  close (FPREP) ;
  if ($alarm == 1) {
    if ($iuser == 1) {
      system ("mail $aemail -s \"Viruswarnung: Ihr persoenliches Verzeichnis ist infiziert!\" <$virusinfo") ; 
    }
    system ("mail viradmin -s \"Viruswarnung in $auser\" <$virusinfo") ; 
    if ($verbose == 1) {
      print "$persinfo\n**************************************************\n" ;
    }
  } else {
    print "ok - kein Virus in $auser\n" ;
  }
}

sub quarantaene {
  my $auser = $_[1] ;
  my @fpinfo = split(/\n|\r/,$_[0]) ;
  my $vdatliste = $_[2] ;
  my $qdir = "$quardir/$auser" ;
  $qdir=~ s/\/\//\//g ;
  for (@fpinfo) {
    if (!/ Infection\: /) { next }
    my ($ldatname,$diagnose,@rest) = split (/ Infection: /,$_) ;
    $ldatname=~ s/ $//g ;
    # Archiv?
    if ($ldatname=~ /\-\>\?/) {
      ($ldatname,@rest) = split(/\-\>\?/,$ldatname) ;
    } elsif ($ldatname=~ /\-\>/) {
      ($ldatname,@rest) = split(/\-\>/,$ldatname) ;
    }
    my $kdatname = $ldatname ;
    $kdatname =~ s/\/$auser\///g ;
    $kdatname =~ s/\/home//g ;
    my $datname = $kdatname ;
    $datname =~ s/\//_/g ;
    $datname =~ s/ //g ;
    $azeit++ ;
    system ("mkdir -p $qdir") ;
    system ("cp \"$ldatname\" \"$qdir/$azeit-$datname\"") ;
    unlink $ldatname ;
    $vdatliste.= "$ldatname ---> $azeit-$datname\nVirus-Befund: $diagnose\n" ;
  }
  
  $_[2] = "Quarantaeneverzeichnis: $qdir\n$vdatliste" ;
    
}


sub benutzerliste {
  my (@benutzer) ;
  open(FILE, "</etc/passwd") || die "nix da!" ;
  my @lines = <FILE>;
  close(FILE);
  for (@lines) {
    my @feld = split (/\:/,$_) ;
    if (($feld[2] > 499)&&($feld[0] ne "admin")) {
      push (@benutzer,$feld[0]) ;
    }
  }
  return @benutzer
}

sub sonstliste {
  # Liste der nicht einem Benutzer gehoerenden homedirs
  # admin wird ausgespart
  my @dirlist = () ;
  my @alledirs = () ;
  opendir (DIRL,"/home") ;
  @alledirs = grep !/^\.\.?$/, readdir(DIRL) ;
  closedir (DIRL) ;
  foreach $hdir (@alledirs) {
    if ((grep($_ eq $hdir,@benutzer))) { next }
    if ($hdir eq "admin") { next }
    push (@dirlist,$hdir) ;
  }
  return @dirlist 
}

sub oeffliste {
  my @ol = () ;
  my @olist = () ;
  open(FILE, "<$confdat") ;
  my @lines = <FILE>;
  close(FILE);
  for (@lines) {
    s/\n|\r//g ;
    if (!(/oeffentlich\=/)) { next }
    my ($dummy,$oliste) = split (/=/,$_) ;
    $oliste=~ s/ {1} */ /g ;
    @olist = split (/ /,$oliste) ;
    last 
  }
  for (@olist) {
    s/ //g ;
    if ($_ ne "") {
      push (@ol,$_) ;
    }
  }
  return @ol 
}

################################################################
